# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from sr_ronex_msgs/TCATState.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import sr_ronex_msgs.msg
import std_msgs.msg

class TCATState(genpy.Message):
  _md5sum = "111c06a71da4f225240b922d7dd93b63"
  _type = "sr_ronex_msgs/TCATState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header

#digital and analogue contain either 6 or 12 elements depending on whether
# a stacker board is attached to the RoNeX or not.
uint16 sequence_number
sr_ronex_msgs/ReceiverData[4] received_data

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sr_ronex_msgs/ReceiverData
bool data_received
uint16[] reserved
sr_ronex_msgs/ImpulseSample[] impulse_response
uint16 first_sample_number
uint16[] payload
uint32 rx_frame_information
uint16 std_noise
uint32 flags
float32 FPI
float64 timestamp_ns

================================================================================
MSG: sr_ronex_msgs/ImpulseSample
int16 real
int16 imaginary
"""
  __slots__ = ['header','sequence_number','received_data']
  _slot_types = ['std_msgs/Header','uint16','sr_ronex_msgs/ReceiverData[4]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,sequence_number,received_data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TCATState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.sequence_number is None:
        self.sequence_number = 0
      if self.received_data is None:
        self.received_data = [sr_ronex_msgs.msg.ReceiverData(),sr_ronex_msgs.msg.ReceiverData(),sr_ronex_msgs.msg.ReceiverData(),sr_ronex_msgs.msg.ReceiverData()]
    else:
      self.header = std_msgs.msg.Header()
      self.sequence_number = 0
      self.received_data = [sr_ronex_msgs.msg.ReceiverData(),sr_ronex_msgs.msg.ReceiverData(),sr_ronex_msgs.msg.ReceiverData(),sr_ronex_msgs.msg.ReceiverData()]

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_H.pack(self.sequence_number))
      for val1 in self.received_data:
        buff.write(_struct_B.pack(val1.data_received))
        length = len(val1.reserved)
        buff.write(_struct_I.pack(length))
        pattern = '<%sH'%length
        buff.write(struct.pack(pattern, *val1.reserved))
        length = len(val1.impulse_response)
        buff.write(_struct_I.pack(length))
        for val2 in val1.impulse_response:
          _x = val2
          buff.write(_struct_2h.pack(_x.real, _x.imaginary))
        buff.write(_struct_H.pack(val1.first_sample_number))
        length = len(val1.payload)
        buff.write(_struct_I.pack(length))
        pattern = '<%sH'%length
        buff.write(struct.pack(pattern, *val1.payload))
        _x = val1
        buff.write(_struct_IHIfd.pack(_x.rx_frame_information, _x.std_noise, _x.flags, _x.FPI, _x.timestamp_ns))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.received_data is None:
        self.received_data = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 2
      (self.sequence_number,) = _struct_H.unpack(str[start:end])
      self.received_data = []
      for i in range(0, 4):
        val1 = sr_ronex_msgs.msg.ReceiverData()
        start = end
        end += 1
        (val1.data_received,) = _struct_B.unpack(str[start:end])
        val1.data_received = bool(val1.data_received)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sH'%length
        start = end
        end += struct.calcsize(pattern)
        val1.reserved = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.impulse_response = []
        for i in range(0, length):
          val2 = sr_ronex_msgs.msg.ImpulseSample()
          _x = val2
          start = end
          end += 4
          (_x.real, _x.imaginary,) = _struct_2h.unpack(str[start:end])
          val1.impulse_response.append(val2)
        start = end
        end += 2
        (val1.first_sample_number,) = _struct_H.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sH'%length
        start = end
        end += struct.calcsize(pattern)
        val1.payload = struct.unpack(pattern, str[start:end])
        _x = val1
        start = end
        end += 22
        (_x.rx_frame_information, _x.std_noise, _x.flags, _x.FPI, _x.timestamp_ns,) = _struct_IHIfd.unpack(str[start:end])
        self.received_data.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_H.pack(self.sequence_number))
      for val1 in self.received_data:
        buff.write(_struct_B.pack(val1.data_received))
        length = len(val1.reserved)
        buff.write(_struct_I.pack(length))
        pattern = '<%sH'%length
        buff.write(val1.reserved.tostring())
        length = len(val1.impulse_response)
        buff.write(_struct_I.pack(length))
        for val2 in val1.impulse_response:
          _x = val2
          buff.write(_struct_2h.pack(_x.real, _x.imaginary))
        buff.write(_struct_H.pack(val1.first_sample_number))
        length = len(val1.payload)
        buff.write(_struct_I.pack(length))
        pattern = '<%sH'%length
        buff.write(val1.payload.tostring())
        _x = val1
        buff.write(_struct_IHIfd.pack(_x.rx_frame_information, _x.std_noise, _x.flags, _x.FPI, _x.timestamp_ns))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.received_data is None:
        self.received_data = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 2
      (self.sequence_number,) = _struct_H.unpack(str[start:end])
      self.received_data = []
      for i in range(0, 4):
        val1 = sr_ronex_msgs.msg.ReceiverData()
        start = end
        end += 1
        (val1.data_received,) = _struct_B.unpack(str[start:end])
        val1.data_received = bool(val1.data_received)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sH'%length
        start = end
        end += struct.calcsize(pattern)
        val1.reserved = numpy.frombuffer(str[start:end], dtype=numpy.uint16, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.impulse_response = []
        for i in range(0, length):
          val2 = sr_ronex_msgs.msg.ImpulseSample()
          _x = val2
          start = end
          end += 4
          (_x.real, _x.imaginary,) = _struct_2h.unpack(str[start:end])
          val1.impulse_response.append(val2)
        start = end
        end += 2
        (val1.first_sample_number,) = _struct_H.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sH'%length
        start = end
        end += struct.calcsize(pattern)
        val1.payload = numpy.frombuffer(str[start:end], dtype=numpy.uint16, count=length)
        _x = val1
        start = end
        end += 22
        (_x.rx_frame_information, _x.std_noise, _x.flags, _x.FPI, _x.timestamp_ns,) = _struct_IHIfd.unpack(str[start:end])
        self.received_data.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_IHIfd = struct.Struct("<IHIfd")
_struct_H = struct.Struct("<H")
_struct_3I = struct.Struct("<3I")
_struct_B = struct.Struct("<B")
_struct_2h = struct.Struct("<2h")
